%%%%%%%%%%%%%%%%%%%%%%% PROGRAMA DE ANÁLISIS DE IMÁGENES PARA DETECTAR LA POSICIÓN DE UNA PARTÍCULA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%ROJA %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%% IMPORTANTE: Todo lo de que se encuentre después del signo % corresponden a
%%%%%%%%   comentarios  y el programa no intenta ejecutarlos %%%%%%%%%%%%%%%%%%%
clc  % este comando borra la información en la ventana de comando
clear % borra todas las variables alojadas 
close % cierra todas las figuras
%
mov=VideoReader('MOV_1550.mp4');  %CAMBIAR NOMBRE DE VIDEO %%%información del video que se analizará
%N=info.NumFrames; % Número de cuadros que posee el video

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%% TRANSFORMACIÓN DE PIXELES A METROS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
imagen=read(mov,1); % CAMBIAR NOMBRE DEL VIDEO %%%Lee el primer cuadro del video. 
imshow(imagen)
[x1, y2, buttons] = ginput (2); %selecciona dos puntos a lo largo del diámetro y en la dirección
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%horizontal(eje x)

conversion= 3e-3 /(x1(2)-x1(1));
NN=100;% Numero de cuadros por analizar
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 for ii=1:NN %ciclo para leer cada cuadro del video 
 img = read(mov,ii); % Lee cada cuadro del video
 %imshow(img); % Muestra la imagen leída
 %xpromedio=x1(1)+(x1(2)-x1(1))/2;
 %ypromedio=y2(2)+(y2(1)-y2(2))/2;
 %delta=100;
 %img=img(ypromedio-delta:ypromedio+delta,xpromedio-delta:xpromedio+delta,:); %toma la imagen y le resta las componentes verde y azul
 imshow(img)
 ImgCortada=img(:,:,1)-img(:,:,2)-img(:,:,3); %toma la imagen y le resta las componentes verde y azul
 %BB=im2bw(img,); %Cambia a binario la imagen anterior
   
  BB=im2bw(ImgCortada,0); %Cambia a binario la imagen anterior
  [mxpos,xpos(ii,1)]=max(double(sum(BB))); %Identifica la coordenada en x del máximo
  [mypos,ypos(ii,1)]=max(double(sum(BB'))); %Identifica la coordenada en y del máximo
% 
  imshow(BB) %  Muestra la imagen con la información de rojo
 hold on  % permite graficar sobre la imagen
  plot(xpos(ii,1),ypos(ii,1),'o r'); %pause%Grafica la coordenada (x,y) encontrada previamente
% 
 ii;
 end
 fps=mov.FrameRate; %cuadros por segundo
 tiempo=NN*(1/fps); %tiempo del video
 xposm=xpos*conversion;
 yposm=ypos*conversion;
 figure; hist(xposm,10)% grafica histograma, numero de bins
 varianzax=var(xposm); %calcula la varianza en el eje x
 varianzay=var(yposm); %calcula la varianza en el eje y
 varianza_total=sqrt(varianzax^2+varianzay^2); %calcula la varianza total
 Difusion= varianza_total/(2*tiempo); %calcula el coeficiente de difusión
